/*************************************************************************
* The Label class
*
*
**************************************************************************/

#ifndef LABEL
#define LABEL


#include "node.h"
#include "MyImage.h"
#include "stdafx.h"



class Label
{
public:
	/**
	*Constructor of the gap label
	*
	*
	*/
	Label();

	/**
	* Get ID of the label
	*/
	int getID();

	/**
	* Get width of the label
	*/
	int getWidth();

	/**
	* Get height of the label
	*/
	int getHeight();

	int getTileNumber();


	/**
	* If the two point are in the same tile
	*/
	void setLabel(int I_ID, int I_width, int I_height, int I_image_width, int I_image_height, float **ori_map,float **I_locations);
	MNode * returnTiles();
	int getTileIndex(CPoint p);
	CPoint returnCenter(CPoint p);


private:
	//ID of this label
	int ID;
	// The width and height define the shape and size of the tiles that belong to this label
	int width;
	int height;

	int tile_num;

	int image_width;
	int image_height;

	MNode *locations;
	int **tile_map;
};

#endif