#include "stdafx.h"
#include "MyImage.h"
#include "LabelSet.h"

#include "stdio.h"
#include "math.h"

#define UNPROCESSED 0
#define PROCESSED 1

LabelSet::LabelSet(MyImage *I_image, float **I_ori_map)
{
	image = I_image;
	ori_map = I_ori_map;
	image_height = image->m_height;
	image_width = image->m_width;
	num_label = 0;
}

LabelSet::LabelSet()
{
	image = NULL;
	ori_map = NULL;
	image_height = 0;
	image_width = 0;
	num_label = 0;
}

LabelSet::~LabelSet()
{
}

int LabelSet::addLabel(int width, int height,float **sites)
{
	if(num_label >= MAX_LABEL)
	{
		printf("Too many labels!\n");
		return -1;
	}
	
	if(sites == NULL)
	{
		printf("No site map!\n");
		return num_label;
	}

	labels[num_label].setLabel(num_label,width,height,image_width,image_height,ori_map,sites);
	num_label++;
	return num_label;
}

int LabelSet::getImageHeight(){return image_height;}

int LabelSet::getImageWidth(){return image_width;}

Label * LabelSet::getLabel(int ID)
{
	if(ID > MAX_LABEL -1 || ID < 0)return NULL;
	else
		return (&(labels[ID]));
}

int LabelSet::getLabelNum()
{
	/*if(num_label >= MAX_LABEL)
	{
		printf("Too many labels!\n");
		return -1;
	}*/	
	return num_label;
}