#pragma once

#include "stdafx.h"
#include "node.h"

#include "labelSet.h"
#include "MyImage.h"
#include "integral_image.h"
#define MAX_ORIENTATION 32

class Mosaic
{
public:

//	Mosaic(MyImage *I_image, int **region, int m_width, int m_height);
	Mosaic(MyImage *I_image, int m_width, int m_height, int ori_num);
	~Mosaic(void);

//	int buildLabelSet(int width, int height);
	void generateMosaic();
//	MNode *generateMosaic();
	void visualizeData();
	void visualizeOri();
	void visualizeTile(int i);
	void visualizeTile(char *fileName);
	void visualizeLabel(int label);
	void changeParameter(int wv, int we, int wd, int ws, float wg);
	void findGap(int FirstLabel, int SecondLabel);

private:
	LabelSet *labelSet;
	MyImage *image;
	//int **m_region;//the region to be tiled
	float **gradient_map;
	float **edge_map;
	float **ori_map;
	float **ori_data;
	int ori_number;
	IntegralImage iImages[MAX_ORIENTATION];

	//these are the pre-computed intersection and gap
	int *intersect;
	float *gap;

	int tileNumber;
	int **tile_map;
//	MNode *tile_map;
	
	int width;
	int height;

	//weight of variance part
	int WV;
	//weight of edge around, negative
	int WE;
	//weight of direction of distance map
	int WD;
	//weight of smoothness term
	int WS;
	//weight of gradient
	float WG;

	//The width and height for intersection array
	int inter_width;
	int inter_height;

	//The center for intersection compute
	int CENTER_X;
	int CENTER_Y;
	
	void compute_intersect();
	void compute_gap();
	bool ifIntersect(CPoint center1, CPoint center2);
	int overlapSize(CPoint center1, CPoint center2);
	float gapSize(CPoint center1, CPoint center2);

	void generateOri();
	void layTile();
	int ** buildLabels();
	int ** buildLabelsFast();
};
